// $Id: ANEPOptionType.java,v 1.2 2000/02/14 14:44:44 sdalu Exp $

package java.net;

/**
 * This interface list the ANEP option type which have
 * been defined by the ANANA. <p>
 *
 * Some of theses options are computed by the kernel itself, so it is not
 * possible to explictly specify their content (it will simply
 * be ignored), this is the case for <code>CHECKSUM</code>
 *
 * @version  $Revision: 1.2 $
 * @author Stephane D'Alu
 */

public interface ANEPOptionType {
    /**
     * Source identifier.
     */
    final static public int SRCID    = 1;

    /**
     * Destination identifier.
     */
    final static public int DSTID    = 2;

    /**
     * Checksum (will be ignored).
     */
    final static public int CHECKSUM = 3;

    /**
     * N/N Authentication.
     */
    final static public int NNAUTH   = 4;
}
