// $Id: ANEPPacketType.java,v 1.3 2000/05/03 10:41:02 sdalu Exp $

package java.net;

/**
 * This interface list the ANEP packet type which have
 * been defined by the ANANA. See 
 * <A href="http://www.isi.edu/~braden/anana/info/typeid.txt">http://www.isi.edu/~braden/anana/info/typeid.txt</A> for more information.
 *
 * @version $Revision: 1.3 $
 * @author Stephane D'Alu
 */
public interface ANEPPacketType {
    final static public int ANTS                               = 18;
    final static public int PLAN                               = 19;
    final static public int Spanner                            = 24;
    final static public int NetScript_ProgramDeploymentPackets = 31;
    final static public int NetScript_PacketTraffic            = 32;
    final static public int NetScript_ManagementTraffic        = 33;
    final static public int ANCORS_daemon                      = 51;
    final static public int ANAIS_Management1                  = 71;
    final static public int ANAIS_Management2                  = 72;
    final static public int ANAIS_Data                         = 73;
    final static public int ANAIS_Multicast                    = 74;
    final static public int ANAIS_Reserved                     = 75;
    final static public int MO_messengers                      = 77;
    final static public int Anet                               = 81;
    final static public int Anet_simulation                    = 82;
    final static public int DAN                                = 86;
}
