package anep;

import java.net.*;
import java.io.*;

public class server {
    static byte[] data = new byte[1024];
    static byte[] opt1 = new byte[1024];
    static byte[] opt2 = new byte[1024];

    static public void main (String args[]) {
	/* Fetch / check argument */
	if (args.length != 2) {
	    System.err.println("Usage: anep.server addr type");
	    System.exit(-1);
	}
	String host = args[0];
	int    type = Integer.parseInt(args[1]);

	/* Fetch IP address fo host */
	InetAddress address = null;
	try {
	    address = InetAddress.getByName(host);
	} catch (UnknownHostException e) {
	    System.err.println("FAILED: " + e.toString());
	    System.exit(-1);
	}

	/* Summary some information */
	System.out.println("IP  : " + address.getHostAddress());
	System.out.println("Type: " + type);

	/* Build packet (for reception) */
	ANEPOption[] options = { new ANEPOption(15, opt1, 0, opt1.length),
				 new ANEPOption(16, opt2, 0, opt2.length) };
	ANEPPacket packet = new ANEPPacket(data, 0, data.length, options);

	/* Receive 1 packet */
	try {
	    /* create socket */
	    ANEPSocket socket = new ANEPSocket(type, address);
	    System.out.println("Listening on: " + 
			       socket.getLocalAddress().getHostAddress());

	    /* Allow delivery of option 15 and 16 */
	    int [] optype = {15, 16};
	    socket.allowOptionTypes(optype);

	    /* Receive packet */
	    socket.receive(packet);
	} catch (Exception e) {
	    System.err.println("FAILED: " + e.toString());
	    System.exit(-1);
	}
	
	/* Print information */
	address = packet.getAddress();
	System.out.println("Received packet from : " + address.getHostName());
	System.out.println("Packet   : " + new String(packet.getData()));
	if (options[0].isReceived())
	    System.out.println("Option 15: "+new String(options[0].getData()));
	if (options[1].isReceived())
	    System.out.println("Option 16: "+new String(options[1].getData()));
    }
}
